<?php
$email = 'xxx@abc.com';
$password = '12345678';
$allow_country=['US','CA'];
$allow_ip_score = 100;
$allow_fp_score = 100;
$allow_device = ['desktop', 'tablet', 'mobile'];
$landing_page = 'landing_page.html';
$safe_page = 'safe_page.html';
session_start();
if (isset($_SESSION['trafficfilter_visitor_id'])) {
    if (isset($_SESSION['trafficfilter_result'])) {
        unset($_SESSION['trafficfilter_result']);
        include($landing_page);
    } else {
        $data = request_trafficfilter([
            'action' => 'get_result',
            'email' => $email,
            'password' => $password,
            'client_ip' => ip_trafficfilter(),
            'identifier' => $_SERVER['HTTP_HOST'],
            'data' => $_SESSION['trafficfilter_visitor_id']
        ]);
        if ($data['ip_score'] >= $allow_ip_score && $data['fingerprint_score'] >= $allow_fp_score && in_array($data['country'], $allow_country) && in_array($data['device'], $allow_device)) {
            include($landing_page);
        } else {
            echo file_get_contents($safe_page);
        }
    }
} else {
    if ($_SERVER['REQUEST_METHOD'] == 'GET') {
        $data = request_trafficfilter([
            'action' => 'get_replace',
            'email' => $email,
            'password' => $password,
        ]);
        $content = file_get_contents($safe_page);
        if (isset($data['search'][0]) && isset($data['replace'][0])) {
            $content = str_replace($data['search'], $data['replace'], $content);
        }
        echo $content;
    } else {
        $post_data = isset($_POST['_']) ? $_POST['_'] : '';
        $data = request_trafficfilter([
            'action' => 'get_result',
            'email' => $email,
            'password' => $password,
            'client_ip' => ip_trafficfilter(),
            'identifier' => $_SERVER['HTTP_HOST'],
            'data' => $post_data
        ]);
        if ($data['visitor_id']) {
            $_SESSION['trafficfilter_visitor_id'] = $data['visitor_id'];
            if ($data['ip_score'] >= $allow_ip_score && $data['fingerprint_score'] >= $allow_fp_score && in_array($data['country'], $allow_country) && in_array($data['device'], $allow_device)) {
                $_SESSION['trafficfilter_result'] = true;
                echo '1';
            }
        }
    }
}
function ip_trafficfilter()
{
    if (isset($_SERVER['HTTP_CF_CONNECTING_IP'])) {
            return $_SERVER['HTTP_CF_CONNECTING_IP'];
        } elseif (isset($_SERVER['HTTP_X_FORWARDED_FOR'])) {
            $ip_arr = explode(',', $_SERVER['HTTP_X_FORWARDED_FOR']);
            return $ip_arr[0];
        } else {
            return $_SERVER['REMOTE_ADDR'];
        }
}
function request_trafficfilter($data)
{
    $curl = curl_init();
    curl_setopt($curl, CURLOPT_URL, 'https://trafficfilter.io/v3');
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($curl, CURLOPT_POSTFIELDS, http_build_query($data));
    $res = curl_exec($curl);
    if (is_array(json_decode($res, true))) {
        $res = json_decode($res, true);
    } else {
        echo $res;
    }
    curl_close($curl);
    return $res;
}